/* ****************************************************************************

                    XMMH - X Maxi-MineHunt - X version of MMH

                (c) 1999,2000,2001 by FlashCode (Sebastien Helleu)
                      Last update: 26/08/2001 by FlashCode

                            http://flashcode.free.fr
                            e-mail:flashcode@free.fr

   ****************************************************************************

==== This program is free software; you can redistribute it and/or modify
==== it under the terms of the GNU General Public License as published by
==== the Free Software Foundation; either version 2 of the License, or
==== (at your option) any later version.
====
==== This program is distributed in the hope that it will be useful,
==== but WITHOUT ANY WARRANTY; without even the implied warranty of
==== MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
==== GNU General Public License for more details.
====
==== You should have received a copy of the GNU General Public License
==== along with this program; if not, write to the Free Software
==== Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Auteur  : FlashCode <flashcode@free.fr>
Creation: 12/02/1999

26/08/2001: FlashCode:
    - ajout de la licence
    - reecriture du source
*/

static char id[] = "$Id: XMMH (c) Copyright 2001/08/26 by FlashCode <flashcode@free.fr> $";


#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <sys/time.h>

#include <X11/Xlib.h>
#include <X11/Xutil.h>


#define FONTE_DEFAUT    "linux8x16"

#define DEBUTANT        0
#define NORMAL          1
#define EXPERT          2
#define PROFESSIONNEL   3

#define MIN_X           3
#define MIN_Y           3
#define MAX_X           50
#define MAX_Y           50

#define PERDU           1
#define GAGNE           2


Display         *display;       /* affichage X-Window                          */
Window          window;         /* fenetre de Xmmh sous X                      */
Pixmap          pixmap;         /* pixmap (fenetre virtuelle)                  */
int             win_width;      /* largeur window & pixmap                     */
int             win_height;     /* hauteur window & pixmap                     */
int             screen;         /* ecran Xmmh                                  */
Colormap        colormap;       /* colormap                                    */
XSizeHints      sizehints;      /* proprietes de la fenetre                    */
GC              gc;             /* gc                                          */
XGCValues       values;         /* valeurs (pour XCreateGC)                    */
XFontStruct     *mainfont;      /* fonte de Xmmh sous X-Window                 */
static Atom     wm_del_win;     /* pour la fermeture propre de la fenetre Xmmh */
unsigned char   *couleurs[16] = /* couleurs standard */
                { "#000000000000", "#0000aa", "#00aa00", "#00aaaa", "#aa0000",
                  "#aa00aa", "#aa5500", "#aaaaaa", "#555555", "#5555ff", "#55ff55",
                  "#55ffff", "#ff5555", "#ff55ff", "#ffff55", "#ffffffffffff" };
unsigned int    xcolor[16];     /* les 16 couleurs standard allouees           */
unsigned char   nom_fonte[256]; /* nom de la fonte X-Window                    */
int             car_x, car_y;   /* largeur et hauteur d'un caractere           */


int             mode, nbx, nby, nbm, tcx, tcy, nb_drap, nb_drap_ok;
unsigned char   etat[MAX_X][MAX_Y];     /* cases du champ */
int             dx[8] = { -1, 0, 1, 1, 1, 0, -1, -1 };  /* pour une recherche dans les 8 directions */
int             dy[8] = { -1, -1, -1, 0, 1, 1, 1, 0 };  /* pour une recherche dans les 8 directions */

int             fini;      /* = 1 si perdu,  = 2 si gagne */


/*  Etat d'une case: (sur 1 seul octet !)

              128  64  32  16  8   4   2   1
             Ŀ
              7  6  5  4  3  2  1  0 
             
                         
  1=le joueur                   
   a perdu ici                    
                                  
   1=mine dessous                 nombre de mines autour
                          
       1=drapeau pose     1=case decouverte (0=encore cachee)
*/


/*
 * affiche_aide: affiche l'aide de X Maxi-MineHunt
 */

void affiche_aide()
{
    printf("\nX Maxi-MineHunt  (c) Copyright 2001/08/26 by Flashcode (Sebastien Helleu)\n\n");
    printf("Syntax:  xmmh [b|n|e|p] [x*y*m] [%%s] [-ffont] [-license]\n\n");
    printf("   mode b/n/e/p: game mode\n");
    printf("                 b=beginner    :  8 *  8;  10m\n");
    printf("                 n=normal      : 16 * 16;  40m\n");
    printf("                 e=expert      : 30 * 30; 100m\n");
    printf("                 p=professional: 50 * 50; 350m\n");
    printf("          x*y*m: x-size (3..50), y-size (3..50), # mines (1..[x*y-1])\n");
    printf("             %%s: s=size of square (12..20)\n");
    printf("           font: X-Window font name (default: \"linux8x16\")\n");
    printf("        license: displays XMMH license\n\n");
    printf("Default options:  b %%18 -flinux8x16\n\n");
    printf("To play:\n");
    printf("  Left button : explore square\n");
    printf("  Right button: drop/remove flag\n");
    printf("  Enter       : restart with same config\n");
    printf("  Esc         : quit\n");
    printf("  Any button  : (when game finished) restart\n\n");
    exit(0);
}

/*
 * affiche_licence: affiche la licence de XMMH
 */

void affiche_licence()
{
    printf("\nXMMH  (c) Copyright 1999,2000,2001 by FlashCode (Sebastien Helleu)\n\n");
    printf("This program is free software; you can redistribute it and/or modify\n");
    printf("it under the terms of the GNU General Public License as published by\n");
    printf("the Free Software Foundation; either version 2 of the License, or\n");
    printf("(at your option) any later version.\n");
    printf("\n");
    printf("This program is distributed in the hope that it will be useful,\n");
    printf("but WITHOUT ANY WARRANTY; without even the implied warranty of\n");
    printf("MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the\n");
    printf("GNU General Public License for more details.\n");
    printf("\n");
    printf("You should have received a copy of the GNU General Public License\n");
    printf("along with this program; if not, write to the Free Software\n");
    printf("Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA\n\n");
    exit(0);
}

/*
 * analyse_ligne_cmd: analyse la ligne de commande
 */

void analyse_ligne_cmd(int argc, char *argv[])
{
    int     i, entier;
    int     nb[4][3] =
            { { 8, 8, 10 }, { 16, 16, 40 }, { 30, 30, 100 }, { 50, 50, 350 } };
    char    *pos1, *pos2;

    mode = -1;
    nbx = 8; nby = 8; nbm = 10; tcx = 18; tcy = 18;
    nom_fonte[0] = '\0';
    for (i = 1; i < argc; i++)
        if (strcasecmp(argv[i], "b") == 0)
            mode = DEBUTANT;
        else
        if (strcasecmp(argv[i], "n") == 0)
            mode = NORMAL;
        else
        if (strcasecmp(argv[i], "e") == 0)
            mode = EXPERT;
        else
        if (strcasecmp(argv[i], "p") == 0)
            mode = PROFESSIONNEL;
        else
        if (argv[i][0] == '%')
        {
            entier = atoi(argv[i]+1);
            if ( (entier < 12) || (entier > 20) )
            {
                fprintf(stderr, "XMMH Error: invalid square size (%s)\n", &(argv[i][1]));
                exit(1);
            }
            tcx = entier;
            tcy = entier;
        }
        else
        if (strncmp(argv[i], "-f", 2) == 0)
            strcpy(nom_fonte, argv[i]+2);
        else
        {
            pos1 = strchr(argv[i], '*');
            if (pos1 != NULL)
                pos2 = strchr(pos1+1, '*');
            else
                pos2 = NULL;
            if ( (pos1 == NULL) || (pos2 == NULL) )
            {
                fprintf(stderr, "XMMH Error: invalid parameter (%s)\n", argv[i]);
                exit(1);
            }
            pos1[0] = '\0';
            pos2[0] = '\0';
            nbx = atoi(argv[i]);
            nby = atoi(pos1+1);
            nbm = atoi(pos2+1);
            if ( (nbx < MIN_X) || (nbx > MAX_X) || (nby < MIN_Y)
                || (nby > MAX_Y) || (nbm < 1) || (nbm > nbx*nby-1) )
            {
                fprintf(stderr, "XMMH Error: invalid size\n");
                exit(1);
            }
        }
    if (mode >= 0)
    {
        nbx = nb[mode][0];
        nby = nb[mode][1];
        nbm = nb[mode][2];
    }
    if (nom_fonte[0] == '\0')
        strcpy(nom_fonte, FONTE_DEFAUT);
}

/*
 * init_window: initialise la fenetre de xmmh
 */

void init_window()
{
    int             i;
    XColor          xcl, exa;
    XTextProperty   name;
    char            *titre_fenetre = "X Maxi-MineHunt / by FlashCode";
    char            *titre_icone = "xmmh";

    display = XOpenDisplay(NULL);
    if (display == NULL)
    {
        fprintf(stderr, "XMMH Error: can't open window.\n");
        exit(1);
    }
    screen = DefaultScreen(display);
    colormap = DefaultColormap(display, screen);
    /* chargement fonte */
    if ((mainfont = XLoadQueryFont(display, nom_fonte)) == NULL)
    {
        fprintf(stderr, "XMMH Error: font '%s' not found.\n", nom_fonte);
        fprintf(stderr, "Try another font with '-f' parameter ('xmmh -?' for help).\n");
        fprintf(stderr, "(look for fonts in directory '/usr/X11/lib/fonts' and subdirectories)\n");
        exit(1);
    }
    if (XTextWidth(mainfont, "i", 1) != XTextWidth(mainfont, "X", 1))
    {
        fprintf(stderr, "XMMH Error: font not proportional.\n");
        exit(1);
    }
    /* couleurs */
    for (i = 0; i < 16; i++)
        if (XAllocNamedColor(display, colormap, couleurs[i], &xcl, &exa) == 0)
        {
            fprintf(stderr, "XMMH Error: can't allocate color(s).\n");
            exit(1);
        }
        else
            xcolor[i] = xcl.pixel;
    /* creation fenetre principale */
    car_x = XTextWidth(mainfont, "X", 1);
    car_y = 8;
    win_width = nbx*tcx;
    win_height = nby*tcy;
    window = XCreateSimpleWindow(display, RootWindow(display, screen),
        0, 0, win_width, win_height, 5,
        WhitePixel(display, screen), xcolor[8]);
    pixmap = XCreatePixmap(display, window, win_width, win_height,
        DefaultDepth(display, screen));
    /* fin de Xmmh propre */
    wm_del_win=XInternAtom(display,"WM_DELETE_WINDOW",False);
    XSetWMProtocols(display,window,&wm_del_win,1);
    /* gc */
    gc = XCreateGC(display, window, (unsigned long)0, &values);
    XSetFont(display, gc, mainfont->fid);
    XSetForeground(display, gc, WhitePixel(display, screen));

    sizehints.flags = PMinSize | PMaxSize | PSize | PResizeInc;
    /*sizehints.flags = PResizeInc;*/
    sizehints.min_width = win_width;
    sizehints.min_height = win_height;
    sizehints.max_width = win_width;
    sizehints.max_height = win_height;
    sizehints.width_inc = tcx;
    sizehints.height_inc = tcy;
    XSetStandardProperties(display, window,
        "X Maxi-MineHunt / by FlashCode",
        "xmmh", None, 0, 0, &sizehints);

    XStringListToTextProperty(&titre_fenetre, 1, &name);
    XSetWMName(display, window, &name);
    XFree(name.value);
    XStringListToTextProperty(&titre_icone, 1, &name);
    XSetWMIconName(display, window, &name);
    XFree(name.value);

    XMapWindow(display, window);
    XSelectInput(display, window, ExposureMask | KeyPressMask |
        ButtonPressMask | StructureNotifyMask);
}

/*
 * refresh_champ: recopie le champ virtuel a l'ecran
 */

void refresh_champ()
{
    XCopyArea(display, pixmap, window, gc, 0, 0, win_width, win_height, 0, 0);
}

/*
 * refresh_case: recopie une case du champ virtuel a l'ecran
 */

void refresh_case(int x, int y)
{
    XCopyArea(display, pixmap, window, gc, x*tcx, y*tcy, tcx, tcy, x*tcx, y*tcy);
}

/*
 * dessine_case: dessine une case du champ de mine
 */

void dessine_case(Drawable d, int x, int y)
{
    int     x1, y1, x2, y2, xm, ym;
    char    chaine[5];

    x1 = x*tcx;
    y1 = y*tcy;
    x2 = x1+tcx-1;
    y2 = y1+tcy-1;
    xm = x1+(tcx/2);
    ym = y1+(tcy/2);
    if ((etat[x][y] & 16) == 0)     /* case cachee ? */
    {
        XSetForeground(display, gc, xcolor[15]);
        XDrawLine(display, d, gc, x1, y1, x2, y1);
        XDrawLine(display, d, gc, x1, y1, x1, y2);
        XSetForeground(display, gc, xcolor[0]);
        XDrawLine(display, d, gc, x1, y2, x2, y2);
        XDrawLine(display, d, gc, x2, y1, x2, y2);
        if (fini == GAGNE)
            XSetForeground(display, gc, xcolor[14]);
        else
            XSetForeground(display, gc, xcolor[7]);
        XFillRectangle(display, d, gc, x1+1, y1+1, tcx-2, tcy-2);
        if ((etat[x][y] & 32) != 0) /* drapeau pose ? */
        {
            XSetForeground(display, gc, xcolor[6]);
            XDrawLine(display, d, gc, xm-2, ym-5, xm-2, ym+2);
            XDrawLine(display, d, gc, xm-3, ym+3, xm-1, ym+3);
            XDrawLine(display, d, gc, xm-4, ym+4, xm, ym+4);
            XDrawLine(display, d, gc, xm-5, ym+5, xm+1, ym+5);
            XSetForeground(display, gc, xcolor[9]);
            XFillRectangle(display, d, gc, xm-1, ym-5, 2, 5);
            XSetForeground(display, gc, xcolor[15]);
            XFillRectangle(display, d, gc, xm+1, ym-5, 2, 5);
            XSetForeground(display, gc, xcolor[12]);
            XFillRectangle(display, d, gc, xm+3, ym-5, 2, 5);
        }
    }
    else
    {
        /* case devouverte */
        if (fini == PERDU)
            if ((etat[x][y] & 128) != 0)
                XSetForeground(display, gc, xcolor[8]);
            else
                XSetForeground(display, gc, xcolor[0]);
        else
            XSetForeground(display, gc, xcolor[7]);
        XFillRectangle(display, d, gc, x1+1, y1+1, tcx-1, tcy-1);
        if (fini == PERDU)
            XSetForeground(display, gc, xcolor[7]);
        else
            XSetForeground(display, gc, xcolor[8]);
        XDrawLine(display, d, gc, x1, y1, x2, y1);
        XDrawLine(display, d, gc, x1, y1, x1, y2);
        if ((etat[x][y] & 64) != 0) /* mine ? */
        {
            XSetForeground(display, gc, xcolor[12]);
            XDrawLine(display, d, gc, x1+1, y1+1, x2-1, y2-1);
            XDrawLine(display, d, gc, x1+1, y2-1, x2-1, y1+1);
        }
        else
            if ((etat[x][y] & 15) > 0)  /* au moins une mine autour */
            {
                sprintf(chaine, "%d", etat[x][y] & 15);
                XSetForeground(display, gc, xcolor[(etat[x][y] & 15)+8]);
                XDrawString(display, d, gc,
                    x1+(tcx-car_x)/2+1, y1+tcy-(tcy-car_y)/2+1, chaine, 1);
            }
    }
}

/*
 * initialise_champ: initialise le champ de mines (place les mines aleatoirement)
 */

void initialise_champ()
{
    int             i, j, k, x, y;
    unsigned char   autour;
    struct timeval  tv;
    struct timezone tz;

    gettimeofday(&tv, &tz);
    srand(tv.tv_usec*tv.tv_sec);
    for (i = 0; i < nbx; i++)
        for (j = 0; j < nby; j++)
            etat[i][j] = 0;
    for (i = 0; i < nbm; i++)
    {
        do { x = rand()%nbx; y = rand()%nby; } while (etat[x][y] != 0);
        etat[x][y] = 64;
    }
    for (i = 0; i < nbx; i++)
        for (j = 0; j < nby; j++)
        {
            autour = 0;
            for (k = 0; k < 8; k++)
                if ( (i+dx[k] >= 0) && (i+dx[k] < nbx) && (j+dy[k] >= 0)
                    && (j+dy[k] < nby) )
                    autour += (etat[i+dx[k]][j+dy[k]] & 64) >> 6;
            etat[i][j] |= autour;
        }
}

/*
 * dessine_champ: dessine le champ de mines
 */

void dessine_champ(Drawable d)
{
    int     i, j;

    for (i = 0; i < nbx; i++)
        for (j = 0; j < nby; j++)
            dessine_case(d, i, j);
}

/*
 * voisins: decouvre une case et (recursivement) toutes les cases autour si elle est vide
 */

void voisins(int x, int y)
{
    int     i;

    if ( (x < 0) || (x == nbx) || (y < 0) || (y == nby) || ((etat[x][y] & 48) != 0) )
        return;
    etat[x][y] |= 16;
    dessine_case(pixmap, x, y);
    if ((etat[x][y] & 15) == 0)
        for (i = 0; i < 8; i++)
            voisins(x+dx[i], y+dy[i]);
}

/*
 * pose_drapeau: pose/retire un drapeau sur une case non decouverte
 */

void pose_drapeau(int x, int y)
{
    int     i, j;

    if ( ((etat[x][y] & 32) == 0) && (nb_drap == 0) )
        return;
    if ((etat[x][y] & 32) != 0)     /* deja un drapeau sur la case ? */
    {
        nb_drap++;
        if ((etat[x][y] & 64) != 0)
            nb_drap_ok--;
    }
    else
    {
        nb_drap--;
        if ((etat[x][y] & 64) != 0)
            nb_drap_ok++;
    }
    etat[x][y] ^= 32;
    dessine_case(pixmap, x, y);
    if (nb_drap_ok == nbm)
    {
        fini = GAGNE;
        for (i = 0; i < nbx; i++)
            for (j = 0; j < nby; j++)
                if ((etat[i][j] & 64) == 0)
                    etat[i][j] |= 16;
        dessine_champ(window);
        XCopyArea(display, window, pixmap, gc, 0, 0, nbx*tcx, nby*tcy, 0, 0);
    }
}

/*
 * nouvelle_partie: initialise une nouvelle partie
 */

void nouvelle_partie(int affiche_champ)
{
    fini = 0;
    nb_drap = nbm;
    nb_drap_ok = 0;
    initialise_champ();
    if (affiche_champ)
        dessine_champ(pixmap);
    refresh_champ();
}

/*
 * xmmh_main: boucle principale de xmmh (attente evenement X)
 */

void xmmh_main()
{
    XEvent  event;
    int     x, y, i, j, quitte, exp_width, exp_height;

    quitte = 0;
    nouvelle_partie(1);
    while (!quitte)
    {
        XNextEvent(display, &event);
        switch (event.type)
        {
            case Expose:
                if ( (event.xexpose.x < win_width)
                    && (event.xexpose.y < win_height) )
                {
                    if (event.xexpose.x+event.xexpose.width > win_width)
                        exp_width = win_width-event.xexpose.x;
                    else
                        exp_width = event.xexpose.width;
                    if (event.xexpose.y+event.xexpose.height > win_height)
                        exp_height = win_height-event.xexpose.y;
                    else
                        exp_height = event.xexpose.height;
                    XCopyArea(display, pixmap, window, gc,
                        event.xexpose.x, event.xexpose.y,
                        exp_width, exp_height,
                        event.xexpose.x, event.xexpose.y);
                }
                break;
            case KeyPress:
                switch (event.xkey.keycode)
                {
                    case 9: /* Echap = quitter */
                        quitte = 1;
                        break;
                    case 20: /* ')' = cases moins grandes */
                        /* A DEVELOPPER !!! */
                        break;
                    case 21: /* '=' = case plus grandes */
                        /* A DEVELOPPER !!! */
                        break;
                    case 36: /* Enter = recommencer */
                        nouvelle_partie(1);
                        break;
                    default:
                        /*printf("Touche: %d\n", event.xkey.keycode);*/
                        break;
                }
                break;
            case ButtonPress:   /* bouton appuye */
                x = event.xbutton.x/tcx;
                y = event.xbutton.y/tcy;
                switch (event.xbutton.button)
                {
                    case 1: /* bouton gauche = decouvrir case (recommencer si fini) */
                        if (fini)
                            nouvelle_partie(1);
                        else
                            if ( (x < nbx) && (y < nby) && ((etat[x][y] & 32) == 0) )
                            {
                                if ((etat[x][y] & 64) != 0)     /* mine dessous ? */
                                {
                                    fini = PERDU;
                                    etat[x][y] |= 128;
                                    for (i = 0; i < nbx; i++)
                                        for (j = 0; j < nby; j++)
                                            etat[i][j] |= 16;
                                    dessine_champ(window);
                                    XCopyArea(display, window, pixmap, gc, 0, 0,
                                        nbx*tcx, nby*tcy, 0, 0);
                                }
                                else
                                {
                                    voisins(x, y);
                                    refresh_champ();
                                }
                            }
                        break;
                    case 2: /* bouton du milieu  = recomencer si fini */
                        if (fini)
                            nouvelle_partie(1);
                        break;
                    case 3: /* bonton droit = poser drapeau (recommencer si fini) */
                        if (fini)
                            nouvelle_partie(1);
                        else
                            if ( (x < nbx) && (y < nby) )
                            {
                                pose_drapeau(x, y);
                                refresh_case(x, y);
                            }
                        break;
                }
                break;
            case ClientMessage: /* quitte */
                return;
        }
    }
}

int main(int argc, char *argv[])
{
    if (argc == 2)
    {
        if (strcmp(argv[1], "-?") == 0)
            affiche_aide();
        if (strcasecmp(argv[1], "-license") == 0)
            affiche_licence();
    }
    analyse_ligne_cmd(argc, argv);
    init_window();
    xmmh_main();
    XFreeGC(display, gc);
    XCloseDisplay(display);
    return 0;
}
